<template>
  <v-layout align-center justify-center>
    <v-flex md3 sm8 xs11>
      <BaseCard :title="$t('login.TITLE')">
        <form @submit.prevent="submit">
          <v-layout column>
            <v-flex>
              <v-text-field
                :error="errors.has('phone')"
                :error-messages="errors.collect('phone')"
                :label="$t('login.PHONE')"
                autocomplete="off"
                data-vv-validate-on="change|blur"
                id="phone"
                data-vv-as="Телефон"
                name="phone"
                type="phone"
                v-model="phone"
                v-validate="'required'"
              ></v-text-field>
            </v-flex>
            <v-flex>
              <v-text-field
                :error="errors.has('password')"
                :error-messages="errors.collect('password')"
                :label="$t('login.PASSWORD')"
                autocomplete="off"
                data-vv-validate-on="change|blur"
                id="password"
                data-vv-as="Пароль"
                name="password"
                type="password"
                v-model.lazy="password"
                v-validate="'required|min:6'"
              ></v-text-field>
            </v-flex>

            <v-flex mt-1 text-xs-center>
              <BaseButton
                :errorsCount="errors.count()"
                :text="$t('login.TITLE')"
                large
              />
            </v-flex>
            <router-link :to="{name: 'signup'}" class="text-xs-center">
              <BaseButton
                :text="$t('signup.TITLE')"
                small
              />
            </router-link>
          </v-layout>
        </form>
      </BaseCard>
    </v-flex>
  </v-layout>
</template>

<script>
  import { mapActions } from 'vuex'
  import router from '@/router'
  import BaseButton from '@/components/base/Button'
  import BaseCard from '@/components/base/Card';

  export default {
    components: { BaseCard, BaseButton },
    data () {
      return {
        phone: '',
        password: ''
      }
    },
    methods: {
      ...mapActions(['getToken', 'getUser']),

      async submit () {
        const valid = await this.$validator.validateAll();
        if (valid) {
          this.getToken({
            login: this.phone,
            password: this.password
          }).then(() => {
            this.getUser()
          })
        }
      }
    },
    created () {
      if (this.$store.getters.isTokenSet) {
        router.push({ name: 'tasks' })
      }
    }
  }
</script>
